# coding: utf-8

"""
    Onfido API v3.6

    The Onfido API (v3.6)

    The version of the OpenAPI document: v3.6
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class PhotoAutoReasons(BaseModel):
    """
    PhotoAutoReasons
    """ # noqa: E501
    digital_tampering: Optional[StrictStr] = Field(default=None, description="Flags when evidence is found that the image was manipulated by Photoshop, or other software.")
    fake_webcam: Optional[StrictStr] = Field(default=None, description="Flags when evidence is found that a fake webcam was used.")
    time_of_capture: Optional[StrictStr] = Field(default=None, description="Flags when evidence is found that the live photo was taken more than 24 hours before live photo upload.")
    emulator: Optional[StrictStr] = Field(default=None, description="Flags when evidence is found that an Android emulator was used.")
    reasons: Optional[StrictStr] = Field(default=None, description="Additional comma separated details such as the exact digital tampering software used, or the name of the fake webcam.")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["digital_tampering", "fake_webcam", "time_of_capture", "emulator", "reasons"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PhotoAutoReasons from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PhotoAutoReasons from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "digital_tampering": obj.get("digital_tampering"),
            "fake_webcam": obj.get("fake_webcam"),
            "time_of_capture": obj.get("time_of_capture"),
            "emulator": obj.get("emulator"),
            "reasons": obj.get("reasons")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


